package com.diagbot.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.diagbot.dto.CheckInfoDTO;
import com.diagbot.dto.DoctorAdviceDTO;
import com.diagbot.dto.ExamineInfoDTO;
import com.diagbot.dto.ExamineSonInfoDTO;
import com.diagbot.entity.MedLisInfo;
import com.diagbot.mapper.MedLisInfoMapper;
import com.diagbot.service.MedLisInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.diagbot.vo.CheckInfoVO;
import com.diagbot.vo.DoctorAdviceVO;
import com.diagbot.vo.ExamineInfoVO;
import com.diagbot.vo.ExamineSonInfoVO;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zhoutg
 * @since 2020-07-28
 */

@Service
public class MedLisInfoServiceImpl extends ServiceImpl<MedLisInfoMapper, MedLisInfo> implements MedLisInfoService {


    public IPage<ExamineInfoDTO> getExamineInfo(ExamineInfoVO examineInfoVO) {

        List<String> infos = this.baseMapper.getInfo(examineInfoVO.getHospitalId(), examineInfoVO.getBehospitalCode());

        Set<String> infoSet = new HashSet<>();
        for (String s : infos) {
            if (s.contains("化验:")) {
                String[] split = s.split("、");
                for (String info : split) {
                    String[] targetInfos = info.split(":");
                    for (String targetInfo : targetInfos) {
                        if (!"化验".equals(targetInfo)) {
                            infoSet.add(targetInfo);
                        }
                    }
                }
            }
        }

        //获取病人进出院时间
        Map<String, Object> timeMap = this.baseMapper.getTime(examineInfoVO);
        Date behospital_date = (Date) timeMap.get("behospital_date");
        examineInfoVO.setBehospitalDate(behospital_date);
        Date leaveHospitalDate = (Date) timeMap.get("leave_hospital_date");
        examineInfoVO.setLeaveHospitalDate(leaveHospitalDate);

        String s = examineInfoVO.getBehospitalCode();
        examineInfoVO.setBehospitalCode(s.split("_")[0]);

        IPage<ExamineInfoDTO> page = this.baseMapper.getExamineInfo(examineInfoVO, infoSet);
        return page;
    }

    public IPage<ExamineSonInfoDTO> getExamineSonInfo(ExamineSonInfoVO examineSonInfoVO) {
        IPage<ExamineSonInfoDTO> page = this.baseMapper.getExamineSonInfo(examineSonInfoVO);
        return page;
    }


}
